;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@LastK=4025
@DFile=400C
@Seed=4032
@PRBuff00=403C
@PRBuff01=403D
@Scroll21=487D

ORG 4ECB

;================================
; Hopper
;================================
@Hopper
	CALL Scroll21
	LD (HopSpeed+2),A	;Set speed
	LD A,88 
	LD B,14 
	RST 10
	DJNZ -3
	LD HL,HopScr
	LD A,02 
	PUSH AF 
	LD B,55 
	LD A,(HL) 
	RST 10
	INC HL 
	DJNZ -5
	LD A,08 
	LD B,14 
	RST 10
	DJNZ -3
	POP AF 
	DEC A 
	JR NZ -19
	LD B,11 
	LD A,(HL) 
	RST 10
	INC HL 
	DJNZ -5
	LD HL,(DFile)
	INC HL 
	LD B,04 
	LD DE,0004 
	ADD HL,DE 
	LD (HL),17 
	DJNZ -5
@Hop01
	LD HL,(DFile)
	LD DE,00DC 
	ADD HL,DE 
	LD (HL),97 
	LD A,08 
	LD (PRBuff00),A
;================================
@Hop02
	LD HL,(DFile)
	INC HL 
	LD DE,0015 
	ADD HL,DE 
	CALL HopX
	DEC C 
	JR Z Hop01
	ADD HL,DE 
	CALL HopX
	DEC C 
	JR Z Hop01
	LD HL,(DFile)
	LD A,(HL) 
	CP 97			;"g*"
	JR Z +3
	INC HL 
	JR -8
	LD A,(PRBuff00)
	LD (HL),A 
	LD (PRBuff01),HL
	LD HL,(DFile)
	INC HL 
	LD B,06 
	ADD HL,DE 
	DJNZ -3
	CALL HopX
	ADD HL,DE 
	CALL HopX
	LD HL,(PRBuff01)
	LD A,(LastK)
	CP FB			;Left, Q to T
	JR NZ +3
	DEC HL 
	JR +34
	CP DF			;Right, Y to P
	JR NZ +3
	INC HL 
	JR +27
	CP BF			;Jump, 6 to 0
	JR NZ +23
	SBC HL,DE 
	PUSH HL 
	LD HL,(DFile)
	LD BC,00ED 
	ADD HL,BC 
	LD A,(HL) 
	INC A 
	CP A6			;"gA"
	JR NZ +5
	LD (HL),9C 
	DEC HL 
	JR -11
	LD (HL),A 
	POP HL 
	LD A,(HL) 
	CP 76
	JR NZ +4
	LD HL,(PRBuff01)
	LD A,(HL) 
	CP 17			;"*"
	JR NZ +16
	LD (HL),AD 
	LD HL,(DFile)
	INC HL 
	LD A,(HL) 
	CP 76
	RET Z 
	CP 17			;"*"
	JR NZ -9
	JR +16
	CP 80
	JR Z +28
	CP 83
	JR Z +24
	CP 1C			;"0"
	JR Z +20
	CP 08
	JR Z +16
	PUSH AF 
	LD (HL),17 
	LD DE,1000 
	DEC DE 
	LD A,D 
	OR E 
	JR NZ -5
	POP AF 
	LD (HL),A 
	JP Hop01
;================================
	LD (PRBuff00),A
	LD (HL),97 
	LD HL,(DFile)
	LD BC,00F7 
	ADD HL,BC 
	LD A,(HL) 
	AND A 
	JR NZ +8
	LD B,03 
	INC HL 
	LD (HL),9C 
	DJNZ -5
	RET
;================================
	DEC A 
	CP 9B			;"g."
	JR NZ +5
	LD (HL),A5 
	DEC HL 
	JR -22
	LD (HL),A 
@HopSpeed
	LD DE,3000 
	DEC DE 
	LD A,D 
	OR E 
	JR NZ -5
	JP Hop02
;================================
@HopX
	LD C,00 
	LD A,(HL) 
	CP 97			;"g*"
	JR Z +31
	PUSH AF 
	LD B,13 
	INC HL 
	LD A,(HL) 
	DEC HL 
	LD (HL),A 
	INC HL 
	DJNZ -7
	POP AF 
	LD (HL),A 
	ADD HL,DE 
	LD A,(HL) 
	CP 97			;"g*"
	JR Z +13
	PUSH AF 
	LD B,13 
	DEC HL 
	LD A,(HL) 
	INC HL 
	LD (HL),A 
	DEC HL 
	DJNZ -7
	POP AF 
	JR +4
	INC C 
	LD A,(PRBuff00)
	LD (HL),A 
	RET
;==========================
@HopScr
	76
	;Traffic
	00 83 83 83 83 00 00 00 83 83 00 00 83 83 83 00 00 83 83 00 76
	1C 00 00 1C 1C 00 00 1C 00 00 1C 00 00 00 1C 00 00 1C 00 00 76
	83 00 00 83 83 83 00 00 00 83 83 83 00 00 83 83 00 00 00 83 76
	00 1C 00 00 00 1C 00 00 1C 00 00 00 00 1C 00 1C 00 00 1C 00 76
	76
	;River
	80 80 93 94 8E 80 93 94 8E 80 80 80 93 94 8E 80 80 93 94 8E 76
	80 80 0A 0A 02 0B 84 80 80 80 80 0B 02 80 0B 02 80 80 0B 02 76
	80 93 94 8E 80 80 93 94 8E 80 93 94 8E 80 80 93 94 8E 80 80 76
	80 0A 0A 0A 06 80 80 80 80 0A 0A 0A 02 80 80 80 0B 02 80 80 76
	76
	;Score UP=000 TIME= 299
	3A 35 14 9C 9C 9C 08 39 2E 32 2A 14 00 9E A5 A5
;==========================
@RndNum
	LD HL,(Seed)
	LD D,H 
	LD E,L 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,DE 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,DE 
	LD (Seed),HL
	RET
