;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@Keyboard=02BB
@DFile=400C
@Seed=4032
@PRBuff00=403C
@PRBuff02=403E
@PRBuff04=4040
@PRBuff10=404C
@Scroll21=487D

ORG 50E3

;==========================
@GroundStrike
	CALL Scroll21
	LD (Speed+2),A		;Set speed
	LD A,"0"
	LD B,06 
	RST 10			;Print "000000 "
	DJNZ -3
	LD A,76 
	RST 10			;Print N/L
	LD C,09 		;Row count
	LD A,00 
	LD B,13 		;Column count
	RST 10			;Print " "x13
	DJNZ -3
	LD A,76 
	RST 10			;Print N/L
	DEC C 			;Decrease row counter
	JR NZ -13		;Do next row
	LD C,02			;Row count 
	LD A,08			;## 
	LD B,13 		;Column count
	RST 10			;Print ##x2
	DJNZ -3
	LD A,76 
	RST 10			;Print N/L
	DEC C 			;Decrease row counter
	JR NZ -13
	LD HL,(DFile)
	LD DE,00AA 		;Offset
	ADD HL,DE 
	LD (HL),86		;('.), Print ship
	INC HL 
	LD (HL),82 		;(:.)
	LD HL,(DFile)
	LD DE,0007 
	ADD HL,DE 
	LD DE,PRBuff04 
	LD B,06 
	PUSH BC 
	LD BC,0014 
	EX DE,HL 
	LD (HL),E 
	INC HL 
	LD (HL),D 
	INC HL 
	EX DE,HL 
	ADD HL,BC 
	POP BC 
	DJNZ -14
	LD HL,(DFile)
	LD DE,00AA 
	ADD HL,DE 
	LD (PRBuff00),HL
	LD DE,0012 
	ADD HL,DE 
	LD (PRBuff02),HL
@Speed
	LD BC,1000 
	DEC BC 
	LD A,B 
	CP 00
	JR NZ -6
	LD A,(PRBuff10)
	INC A 
	LD (PRBuff10),A
	BIT 0,A 
	JR Z +119
	LD HL,(DFile)
	LD DE,0080 
	ADD HL,DE 
	LD C,03 
	LD D,H 
	LD E,L 
	INC HL 
	LD B,12 
	LD A,(HL) 		;Ship 
	CP 86	
	JR Z +12
	CP 82
	JR NZ +4
	LD A,86 
	JR +17
	CP "."			;Bomb
	JR NZ +4
	LD A,00 
	JR +9
	CP 00
	JR NZ +5
	LD A,(DE) 
	CP 82
	JR NZ -13
	LD (DE),A 
	INC HL 
	INC DE 
	DJNZ -35
	INC HL 
	DEC C 
	JR NZ -44
	LD DE,0012 
	ADD HL,DE 
	PUSH HL 
	CALL RndNum
	LD B,H 
	LD A,01 
	INC A 
	CP 05
	JR NZ +2
	LD A,01 
	DJNZ -9
	LD B,A 
	POP HL 
	LD DE,FFEC 
	LD (HL),08 
	ADD HL,DE 
	DJNZ -5
	CP 04
	JR Z +32
	PUSH AF 
	PUSH HL 
	CALL RndNum
	LD A,H 
	CP 32
	POP HL 
	JR NC +2
	LD (HL),26 
	POP AF 
	INC A 
	LD B,A 
	LD A,04 
	SUB B 
	LD B,A 
	CP 00
	JR Z +8
	LD DE,FFEC 
	ADD HL,DE 
	JR C +0
	DJNZ -5
	LD HL,(PRBuff00)
	INC HL 
	LD A,(HL) 
	CP 82
	JR Z +3
	DEC HL 
	JR +74
	CALL Keyboard
	BIT 0,L 		;Z to V, Down
	JR Z +4
	BIT 1,L 		;A to T, Down
	JR NZ +5
	LD DE,0014 
	JR +11
	BIT 2,L			;Q to T, Up
	JR Z +4
	BIT 3,L			;1 to 5, Up
	JR NZ +56
	LD DE,FFEC 
	LD HL,(PRBuff00)
	LD (HL),00 
	INC HL 
	LD (HL),00 
	ADD HL,DE 
	LD A,(HL) 
	CP 00
	JR NZ +17
	DEC HL 
	LD A,(HL) 
	CP 00
	JR NZ +11
	LD (HL),86 
	INC HL 
	LD (HL),82 
	DEC HL 
	LD (PRBuff00),HL
	JR +22
	LD HL,(PRBuff00)
	CP 08
	JR Z +8
	CP 26			;"A"
	JR Z +4
	CP 34			;"O"
	JR NZ -26
	ADD HL,DE 
	LD (HL),17 
	INC HL 
	LD (HL),17 
	RET
;==========================
	CALL Keyboard
	BIT 4,L 		;6 to 0, Bomb
	JR Z +4
	BIT 4,H			;Move+Bomb 
	JR NZ +14
	LD HL,(PRBuff02)
	LD A,(HL) 
	CP 08
	JR NZ +6
	LD HL,(PRBuff00)
	INC HL 
	JR +62
	LD HL,(PRBuff02)
	LD B,00 
	LD A,(HL) 
	CP 08
	JR Z +33
	CP 26			;"A"
	JR NZ +23
	LD (HL),00 
	LD HL,(DFILE)
	LD DE,0005 
	ADD HL,DE 
	LD A,(HL) 
	INC A 
	CP 26			;"A"
	JR NZ +5
	LD (HL),1C 
	DEC HL 
	JR -11
	LD (HL),A 
	JR +5
	CP 34			;"O"
	JR NZ +14
	LD (HL),B4 
	LD HL,(DFILE)
	LD DE,00BC 
	ADD HL,DE 
	LD (PRBuff02),HL
	JR +20
	LD A,B 
	CP 00
	JR NZ +10
	LD (HL),00 
	LD DE,0015 
	ADD HL,DE 
	LD B,50 
	JR -65
	LD (HL),1B 
	LD (PRBuff02),HL
	LD HL,PRBuff04
	LD B,06 
	PUSH BC 
	LD E,(HL) 
	INC HL 
	LD D,(HL) 
	PUSH HL 
	EX DE,HL 
	LD A,(HL) 
	CP 76
	JR NZ +16
	PUSH HL 
	CALL RndNum
	LD A,H 
	POP HL 
	CP 28
	JR NC +28
	LD DE,0013 
	ADD HL,DE 
	JR +20
	LD (HL),00 
	CP B4
	JR NZ +8
	DEC HL 
	LD A,(HL) 
	CP 76
	JR NZ -6
	JR +8
	DEC HL 
	LD A,(HL) 
	CP 76
	JR Z +2
	LD (HL),34 
	EX DE,HL 
	POP HL 
	LD (HL),D 
	DEC HL 
	LD (HL),E 
	INC HL 
	INC HL 
	POP BC 
	DJNZ -59
	JP Speed
;==========================
@RndNum
	LD HL,(Seed)
	LD D,H 
	LD E,L 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,DE 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,HL 
	ADD HL,DE 
	LD (Seed),HL
	RET
