;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@CLS=0A2A
@Frames=4034
@DFile=400C
@EasyX=4036				;16438, E=138 M=148 H=158
@LastK=4025
@Score=490D
@SpeedX=4998				;18840

ORG 52EE				;21230

;================================
; Highway Robbery
;================================
@Robbery
	CALL CLS
	LD A,(SpeedX)			;Get speed
	LD (Speed+1),A			;Set speed
	LD A,(EasyX)			;Get difficulty
	LD (Easy+1),A			;Set difficulty
	LD A,(Frames)
	LD (HR05),A 
	LD B,90 
	LD A,80				;Print highway
	RST 10
	RST 10
	DJNZ -4
	LD BC,0020 
	LD DE,(DFile)
	INC DE 
	LD HL,Score
	LDIR 
	DEC DE 
	LD (HR03),DE 
	LD HL,(DFile)
@Easy
	LD DE,0094 
	ADD HL,DE 
	LD (HR01),HL 
	LD A,04 
	LD (HR02),A 
@HRLoop
	LD A,08				;Row counter
	LD HL,(HR03) 
	INC HL 
	INC HL 
	PUSH HL 
	POP DE 
	INC HL 
	LD BC,001F 
	LDIR 
	EX DE,HL 
	LD (HL),80			;Road
	EX DE,HL 
	DEC A 
	JR NZ -16
	LD HL,(HR01) 
	LD A,(HL) 
	LD (HR04),A 
	LD (HL),92			;g> 
	LD A,(HR05) 
	LD C,A 
	SLA A 
	SLA A 
	LD B,A 
	SLA A 
	SLA A 
	ADD A,B 
	ADD A,C 
	ADD A,0D 
	LD E,A 
	LD (HR05),A 
	LD C,08 
	XOR A 
	LD B,08 
	RL E 
	RLA 
	SUB C 
	JR NC +3
	ADD A,C 
	DJNZ -9
	INC A 
	LD HL,(HR03) 
	LD DE,0021 
	ADD HL,DE 
	DEC A 
	JR NZ -4
	LD A,(Frames)
	BIT 5,A 
	LD A,88				;Brick
	JR Z +2
	ADD A,05 
	LD (HL),A 
@Speed
	LD BC,FF0F 
	DJNZ -2
	DEC C 
	JR NZ -5
	LD A,(HR04) 
	CP 88				;Brick
	JR Z +18
	CP 8D				;g$
	JR NZ +45
	LD HL,(HR03) 
	INC (HL) 
	LD A,(HL) 
	CP A6				;Score roll over test
	JR NZ +36
	LD (HL),9C			;g0
	DEC HL 
	JR -11
	LD C,85				;Car crash
	LD HL,(HR01) 
	PUSH HL 
	POP DE 
	LD (HL),12			;>
	LD B,05 
	INC DE 
	DEC HL 
	LD (HL),C 
	EX DE,HL 
	LD (HL),C 
	EX DE,HL 
	DJNZ -8
	LD C,B
	RET				;Return 0
	00
;========================
;	LD A,(LastK)
	CP F7				;Restart-1 to 5
	RET Z 
	LD A,C 
	XOR 80 
	LD C,A 
	JR -29
;========================
	LD DE,0021 
	LD HL,(HR01) 
	LD (HL),80 
	LD A,(LastK)
	CP FD				;Down-A to G
	JR Z +7
	CP FB				;  Up-Q to T
	JR Z +20
	JP HRLoop
	LD A,(HR02) 
	CP 08
	JR Z -10
	ADD HL,DE 
	LD (HR01),HL 
	INC A 
	LD (HR02),A 
	JR -20
	LD A,(HR02) 
	DEC A 
	JR Z -26
	LD (HR02),A 
	SBC HL,DE 
	LD (HR01),HL 
	JR -21
;=====================================
;Data and vars
;=====================================
@HR01 
	00 00
@HR02 
	00
@HR03 
	00 00
@HR04 
	00
@HR05 
	00
