;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

@PrintAt=08F5
@DFxCC=400E
@PRBuff00=403C
@Coords=4036
@DFile=400C
@LastK=4025				;Keyboard debounce value
@Frames=4034
@Scroll21=487D

ORG 5428

@Blaster
	CALL Scroll21
	LD (Speed+1),A			;Set speed
	LD C,14 
	LD B,10 
	LD A,80 
	RST 10
	DJNZ -3
	LD A,76 
	RST 10
	DEC C 
	JR NZ -13
	LD HL,(DFxCC)
	DEC HL 
	LD B,10 
	DEC HL 
	LD (HL),21 
	DJNZ -5
	DEC HL 
	DEC HL 
	LD DE,Score 			;LDDR source
	EX DE,HL 
	LD C,10 
	LDDR 
	PUSH BC 
	POP HL 
	LD (PRBuff00),HL
	LD L,06 
	LD (Coords),HL
@Blast01
	LD A,(LastK)
	CP BF
	NOP
	JR Z KeyL
	RES 0,(IY+55)			;Ycoord 
	JR +27
@KeyL
	BIT 0,(IY+55) 			;Ycoord 
	JR NZ +21
	SET 0,(IY+55) 			;Ycoord 
	LD HL,(DFile)
	LD DE,0110 
	ADD HL,DE 
	LD DE,(Coords)
	LD D,00 
	ADD HL,DE 
	LD (PRBuff00),HL
	LD HL,(PRBuff00)
	LD A,H 
	OR L 
	JP Z Blast05
	LD DE,0011 
	LD C,(HL) 
	LD A,C 
	CP 80
	JR Z Blast03
@Blast02
	LD C,(HL) 
	LD A,C 
	LD B,02 
	CP BB				;"gV"
	JR NZ +13
	LD B,05 
	LD DE,0011 
	LD (HL),80			;" " 
	SBC HL,DE 
	LD (HL),97			;"g*" 
	JR +2
	LD (HL),80 			;" "
	CP 97				;"g*"]
	JR NZ +28
	LD HL,(DFile)
	LD DE,0144 
	ADD HL,DE 
	LD A,(HL) 
	CP 21				;"5"
	JR NZ +3
	INC HL 
	JR -8
	LD C,06 
	LD (HL),21 			;"5"
	INC HL 
	LD A,76 
	CP (HL) 
	JR Z +3
	DEC C 
	JR NZ -11
	LD HL,0000 
	LD (PRBuff00),HL
	LD HL,(DFile)
	LD DE,0136 
	ADD HL,DE 
	INC (HL) 
	LD A,A6				;"A" 
	CP (HL) 
	JR NZ +5
	LD (HL),9C 			;"g0"
	DEC HL 
	JR -11
	DJNZ -20
	RES 0,(IY+55)			;Ycoord 
	JR Blast05
@Blast03
	SBC HL,DE 
	PUSH HL 
	LD DE,(DFile)
	SBC HL,DE 
	POP HL 
	JP P Blast04
	LD HL,0000 
	LD (PRBuff00),HL
	JR Blast05
@Blast04
	LD C,(HL) 
	LD A,C 
	CP 80				;"g "
	JR NZ Blast02
	LD (HL),8B 			;"g""
	LD (PRBuff00),HL
@Blast05
	LD HL,Coords 
	LD C,(HL) 
	LD A,(LastK)
	CP DF				;Right?
	JR NZ +1
	INC C
	CP FB				;Left?
	JR NZ +1
	DEC C 
	LD A,C 
	CP 00
	JR NZ +1
	INC C 
	CP 11
	JR NZ +1
	DEC C 
	LD (HL),C 
	LD HL,(DFile)
	LD DE,0121 
	ADD HL,DE 
	ADD HL,BC 
	LD A,80 
	CP (HL) 
	JP NZ Killed
	LD (HL),A6 			;"gA"
	LD HL,(DFile)
	LD DE,0153 
	ADD HL,DE 
	LD A,(HL) 
	CP 76
	JP Z Killed+2
	CP 1C				;"0"
	JR NZ +3
	DEC HL 
	JR -13
	DEC (HL) 
@Speed
	LD B,19 			;Speed
	DEC C 
	JR NZ -3
	DJNZ -5
	LD HL,(DFile)
	LD DE,0121 
	ADD HL,DE 
	PUSH HL 
	LD DE,0011 
	LD C,10 
	LD B,11 
	LD A,97 			;"g*"
	DEC HL 
	PUSH HL 
	CP (HL) 
	JR NZ +12
	ADD HL,DE 
	LD A,(HL) 
	CP 80
	JR NZ +6
	LD (HL),97			;"g*" 
	SBC HL,DE 
	LD (HL),80 
	POP HL 
	DJNZ -22
	DEC C 
	JR NZ -27
	LD HL,(PRBuff00)
	LD (HL),80 
	POP HL 
	ADD HL,DE 
	PUSH HL 
	LD DE,0011 
	SBC HL,DE 
	POP DE 
	LD BC,0121 
	LDDR 
	LD HL,(DFile)
	LD B,10 
	INC HL 
	LD (HL),80 
	DJNZ -5
	LD BC,(Frames)			;Random number
	LD E,C 
	LD B,00 
	LD A,(BC) 
	AND 0F 
	LD C,A 
	SBC HL,BC 
	LD (HL),B4 			;"gO"
	LD A,E 
	AND 0F 
	JR NZ +8
	LD (HL),AD 			;"gH"
	LD DE,0011 
	ADD HL,DE 
	LD (HL),BB 			;"gV"
	CP 0E				;14
	JR C +2
	LD (HL),97 			;"g*"
	JP Blast01
@Killed
	LD (HL),88 			;"gX"
	LD BC,0000
	RET
;================================
	9C 9C 9C 9C 9C 93 B8 A8 B4 B7 AA 80 AB BA AA 
@Score
	B1 				;
;================================
